Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -42,4 +42,6 @@
 #include "CommonDef.h"
 #include "TComRom.h"
+#include "TComChromaFormat.h"
+#include "SEI.h"
 
 //! \ingroup TLibCommon
@@ -54,38 +56,28 @@
 {
 private:
-  
+
   // ------------------------------------------------------------------------------------------------
   //  YUV buffer
   // ------------------------------------------------------------------------------------------------
-  
-  Pel*  m_apiPicBufY;           ///< Buffer (including margin)
-  Pel*  m_apiPicBufU;
-  Pel*  m_apiPicBufV;
-  
-  Pel*  m_piPicOrgY;            ///< m_apiPicBufY + m_iMarginLuma*getStride() + m_iMarginLuma
-  Pel*  m_piPicOrgU;
-  Pel*  m_piPicOrgV;
-  
+
+  Pel*  m_apiPicBuf[MAX_NUM_COMPONENT];             ///< Buffer (including margin)
+
+  Pel*  m_piPicOrg[MAX_NUM_COMPONENT];              ///< m_apiPicBufY + m_iMarginLuma*getStride() + m_iMarginLuma
+
   // ------------------------------------------------------------------------------------------------
   //  Parameter for general YUV buffer usage
   // ------------------------------------------------------------------------------------------------
-  
-  Int   m_iPicWidth;            ///< Width of picture
-  Int   m_iPicHeight;           ///< Height of picture
-  
-  Int   m_iCuWidth;             ///< Width of Coding Unit (CU)
-  Int   m_iCuHeight;            ///< Height of Coding Unit (CU)
-  Int*  m_cuOffsetY;
-  Int*  m_cuOffsetC;
-  Int*  m_buOffsetY;
-  Int*  m_buOffsetC;
-  
-  Int   m_iLumaMarginX;
-  Int   m_iLumaMarginY;
-  Int   m_iChromaMarginX;
-  Int   m_iChromaMarginY;
-  
+
+  Int   m_iPicWidth;                                ///< Width of picture in pixels
+  Int   m_iPicHeight;                               ///< Height of picture in pixels
+  ChromaFormat m_chromaFormatIDC;                   ///< Chroma Format
+
+  Int*  m_ctuOffsetInBuffer[MAX_NUM_CHANNEL_TYPE];  ///< Gives an offset in the buffer for a given CTU (and channel)
+  Int*  m_subCuOffsetInBuffer[MAX_NUM_CHANNEL_TYPE];///< Gives an offset in the buffer for a given sub-CU (and channel), relative to start of CTU
+
+  Int   m_iMarginX;                                 ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
+  Int   m_iMarginY;                                 ///< margin of Luma channel (chroma's may be smaller, depending on ratio)
+
   Bool  m_bIsBorderExtended;
-  
 #if H_3D_IV_MERGE
   Int   m_iBaseUnitWidth;       ///< Width of Base Unit (with maximum depth or minimum size, m_iCuWidth >> Max. Depth)
@@ -93,78 +85,84 @@
   Int   m_iNumCuInWidth;
 #endif
-protected:
-  Void  xExtendPicCompBorder (Pel* piTxt, Int iStride, Int iWidth, Int iHeight, Int iMarginX, Int iMarginY);
-#if H_3D
+
+#if NH_3D_VSO
   Void  xSetPels( Pel* piPelSource , Int iSourceStride, Int iWidth, Int iHeight, Pel iVal );
 #endif
-  
+
 public:
-  TComPicYuv         ();
-  virtual ~TComPicYuv();
-  
+               TComPicYuv         ();
+  virtual     ~TComPicYuv         ();
+
   // ------------------------------------------------------------------------------------------------
   //  Memory management
   // ------------------------------------------------------------------------------------------------
-  
-  Void  create      ( Int iPicWidth, Int iPicHeight, UInt uiMaxCUWidth, UInt uiMaxCUHeight, UInt uiMaxCUDepth );
-  Void  destroy     ();
-  
-  Void  createLuma  ( Int iPicWidth, Int iPicHeight, UInt uiMaxCUWidth, UInt uiMaxCUHeight, UInt uhMaxCUDepth );
-  Void  destroyLuma ();
-  
+
+  Void          create            (const Int iPicWidth,
+                                   const Int iPicHeight,
+                                   const ChromaFormat chromaFormatIDC,
+                                   const UInt uiMaxCUWidth,  ///< used for generating offsets to CUs. Can use iPicWidth if no offsets are required
+                                   const UInt uiMaxCUHeight, ///< used for generating offsets to CUs. Can use iPicHeight if no offsets are required
+                                   const UInt uiMaxCUDepth,  ///< used for generating offsets to CUs. Can use 0 if no offsets are required
+                                   const Bool bUseMargin);   ///< if true, then a margin of uiMaxCUWidth+16 and uiMaxCUHeight+16 is created around the image.
+
+  Void          destroy           ();
+
+  // The following have been removed - Use CHROMA_400 in the above function call.
+  //Void  createLuma  ( Int iPicWidth, Int iPicHeight, UInt uiMaxCUWidth, UInt uiMaxCUHeight, UInt uhMaxCUDepth );
+  //Void  destroyLuma ();
+
   // ------------------------------------------------------------------------------------------------
   //  Get information of picture
   // ------------------------------------------------------------------------------------------------
-  
-  Int   getWidth    ()     { return  m_iPicWidth;    }
-  Int   getHeight   ()     { return  m_iPicHeight;   }
-  
-  Int   getStride   ()     { return (m_iPicWidth     ) + (m_iLumaMarginX  <<1); }
-  Int   getCStride  ()     { return (m_iPicWidth >> 1) + (m_iChromaMarginX<<1); }
-  
-  Int   getLumaMargin   () { return m_iLumaMarginX;  }
-  Int   getChromaMargin () { return m_iChromaMarginX;}
-  
+
+  Int           getWidth          (const ComponentID id) const { return  m_iPicWidth >> getComponentScaleX(id);   }
+  Int           getHeight         (const ComponentID id) const { return  m_iPicHeight >> getComponentScaleY(id);  }
+  ChromaFormat  getChromaFormat   ()                     const { return m_chromaFormatIDC; }
+  UInt          getNumberValidComponents() const { return ::getNumberValidComponents(m_chromaFormatIDC); }
+
+  Int           getStride         (const ComponentID id) const { return ((m_iPicWidth     ) + (m_iMarginX  <<1)) >> getComponentScaleX(id); }
+  Int           getTotalHeight    (const ComponentID id) const { return ((m_iPicHeight    ) + (m_iMarginY  <<1)) >> getComponentScaleY(id); }
+
+  Int           getMarginX        (const ComponentID id) const { return m_iMarginX >> getComponentScaleX(id);  }
+  Int           getMarginY        (const ComponentID id) const { return m_iMarginY >> getComponentScaleY(id);  }
+
   // ------------------------------------------------------------------------------------------------
   //  Access function for picture buffer
   // ------------------------------------------------------------------------------------------------
-  
+
   //  Access starting position of picture buffer with margin
-  Pel*  getBufY     ()     { return  m_apiPicBufY;   }
-  Pel*  getBufU     ()     { return  m_apiPicBufU;   }
-  Pel*  getBufV     ()     { return  m_apiPicBufV;   }
-  
+  Pel*          getBuf            (const ComponentID ch)       { return  m_apiPicBuf[ch];   }
+
   //  Access starting position of original picture
-  Pel*  getLumaAddr ()     { return  m_piPicOrgY;    }
-  Pel*  getCbAddr   ()     { return  m_piPicOrgU;    }
-  Pel*  getCrAddr   ()     { return  m_piPicOrgV;    }
-  
+  Pel*          getAddr           (const ComponentID ch)       { return  m_piPicOrg[ch];   }
+  const Pel*    getAddr           (const ComponentID ch) const { return  m_piPicOrg[ch];   }
+
   //  Access starting position of original picture for specific coding unit (CU) or partition unit (PU)
-  Pel*  getLumaAddr ( Int iCuAddr ) { return m_piPicOrgY + m_cuOffsetY[ iCuAddr ]; }
-  Pel*  getCbAddr   ( Int iCuAddr ) { return m_piPicOrgU + m_cuOffsetC[ iCuAddr ]; }
-  Pel*  getCrAddr   ( Int iCuAddr ) { return m_piPicOrgV + m_cuOffsetC[ iCuAddr ]; }
-  Pel*  getLumaAddr ( Int iCuAddr, Int uiAbsZorderIdx ) { return m_piPicOrgY + m_cuOffsetY[iCuAddr] + m_buOffsetY[g_auiZscanToRaster[uiAbsZorderIdx]]; }
-  Pel*  getCbAddr   ( Int iCuAddr, Int uiAbsZorderIdx ) { return m_piPicOrgU + m_cuOffsetC[iCuAddr] + m_buOffsetC[g_auiZscanToRaster[uiAbsZorderIdx]]; }
-  Pel*  getCrAddr   ( Int iCuAddr, Int uiAbsZorderIdx ) { return m_piPicOrgV + m_cuOffsetC[iCuAddr] + m_buOffsetC[g_auiZscanToRaster[uiAbsZorderIdx]]; }
-  
+  Pel*          getAddr           (const ComponentID ch, const Int ctuRSAddr )       { return m_piPicOrg[ch] + m_ctuOffsetInBuffer[ch==0?0:1][ ctuRSAddr ]; }
+  const Pel*    getAddr           (const ComponentID ch, const Int ctuRSAddr ) const { return m_piPicOrg[ch] + m_ctuOffsetInBuffer[ch==0?0:1][ ctuRSAddr ]; }
+  Pel*          getAddr           (const ComponentID ch, const Int ctuRSAddr, const Int uiAbsZorderIdx )
+                                     { return m_piPicOrg[ch] + m_ctuOffsetInBuffer[ch==0?0:1][ctuRSAddr] + m_subCuOffsetInBuffer[ch==0?0:1][g_auiZscanToRaster[uiAbsZorderIdx]]; }
+  const Pel*    getAddr           (const ComponentID ch, const Int ctuRSAddr, const Int uiAbsZorderIdx ) const
+                                     { return m_piPicOrg[ch] + m_ctuOffsetInBuffer[ch==0?0:1][ctuRSAddr] + m_subCuOffsetInBuffer[ch==0?0:1][g_auiZscanToRaster[uiAbsZorderIdx]]; }
+
+  UInt          getComponentScaleX(const ComponentID id) const { return ::getComponentScaleX(id, m_chromaFormatIDC); }
+  UInt          getComponentScaleY(const ComponentID id) const { return ::getComponentScaleY(id, m_chromaFormatIDC); }
+
   // ------------------------------------------------------------------------------------------------
   //  Miscellaneous
   // ------------------------------------------------------------------------------------------------
-  
+
   //  Copy function to picture
-  Void  copyToPic       ( TComPicYuv*  pcPicYuvDst );
-  Void  copyToPicLuma   ( TComPicYuv*  pcPicYuvDst );
-  Void  copyToPicCb     ( TComPicYuv*  pcPicYuvDst );
-  Void  copyToPicCr     ( TComPicYuv*  pcPicYuvDst );
-  
+  Void          copyToPic         ( TComPicYuv*  pcPicYuvDst ) const ;
+
   //  Extend function of picture buffer
-  Void  extendPicBorder      ();
-  
+  Void          extendPicBorder   ();
+
   //  Dump picture
-  Void  dump (Char* pFileName, Bool bAdd = false);
-  
+  Void          dump              (const Char* pFileName, const BitDepths &bitDepths, Bool bAdd = false) const ;
+
   // Set border extension flag
-  Void  setBorderExtension(Bool b) { m_bIsBorderExtended = b; }
-#if H_3D
+  Void          setBorderExtension(Bool b) { m_bIsBorderExtended = b; }
+#if NH_3D
   // Set Function 
   Void  setLumaTo    ( Pel pVal );  
@@ -176,9 +174,13 @@
 #endif
 #endif
+
 };// END CLASS DEFINITION TComPicYuv
 
-void calcChecksum(TComPicYuv& pic, UChar digest[3][16]);
-void calcCRC(TComPicYuv& pic, UChar digest[3][16]);
-void calcMD5(TComPicYuv& pic, UChar digest[3][16]);
+
+// These functions now return the length of the digest strings.
+UInt calcChecksum(const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths);
+UInt calcCRC     (const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths);
+UInt calcMD5     (const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths);
+std::string hashToString(const TComPictureHash &digest, Int numChar);
 //! \}
 
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1200)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -43,5 +43,5 @@
  */
 template<UInt OUTPUT_BITDEPTH_DIV8>
-static void md5_block(MD5& md5, const Pel* plane, UInt n)
+static Void md5_block(MD5& md5, const Pel* plane, UInt n)
 {
   /* create a 64 byte buffer for packing Pel's into */
@@ -64,5 +64,5 @@
  */
 template<UInt OUTPUT_BITDEPTH_DIV8>
-static void md5_plane(MD5& md5, const Pel* plane, UInt width, UInt height, UInt stride)
+static Void md5_plane(MD5& md5, const Pel* plane, UInt width, UInt height, UInt stride)
 {
   /* N is the number of samples to process per md5 update.
@@ -74,8 +74,10 @@
   for (UInt y = 0; y < height; y++)
   {
-    /* convert pel's into UInt chars in little endian byte order.
+    /* convert pels into unsigned chars in little endian byte order.
      * NB, for 8bit data, data is truncated to 8bits. */
     for (UInt x = 0; x < width_less_modN; x += N)
+    {
       md5_block<OUTPUT_BITDEPTH_DIV8>(md5, &plane[y*stride + x], N);
+    }
 
     /* mop up any of the remaining line */
@@ -84,5 +86,6 @@
 }
 
-static void compCRC(Int bitdepth, const Pel* plane, UInt width, UInt height, UInt stride, UChar digest[16])
+
+UInt compCRC(Int bitdepth, const Pel* plane, UInt width, UInt height, UInt stride, TComPictureHash &digest)
 {
   UInt crcMsb;
@@ -119,25 +122,22 @@
   }
 
-  digest[0] = (crcVal>>8)  & 0xff;
-  digest[1] =  crcVal      & 0xff;
-}
-
-void calcCRC(TComPicYuv& pic, UChar digest[3][16])
-{
-  UInt width = pic.getWidth();
-  UInt height = pic.getHeight();
-  UInt stride = pic.getStride();
-
-  compCRC(g_bitDepthY, pic.getLumaAddr(), width, height, stride, digest[0]);
-
-  width >>= 1;
-  height >>= 1;
-  stride >>= 1;
-
-  compCRC(g_bitDepthC, pic.getCbAddr(), width, height, stride, digest[1]);
-  compCRC(g_bitDepthC, pic.getCrAddr(), width, height, stride, digest[2]);
-}
-
-static void compChecksum(Int bitdepth, const Pel* plane, UInt width, UInt height, UInt stride, UChar digest[16])
+  digest.hash.push_back((crcVal>>8)  & 0xff);
+  digest.hash.push_back( crcVal      & 0xff);
+  return 2;
+}
+
+UInt calcCRC(const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths)
+{
+  UInt digestLen=0;
+  digest.hash.clear();
+  for(Int chan=0; chan<pic.getNumberValidComponents(); chan++)
+  {
+    const ComponentID compID=ComponentID(chan);
+    digestLen=compCRC(bitDepths.recon[toChannelType(compID)], pic.getAddr(compID), pic.getWidth(compID), pic.getHeight(compID), pic.getStride(compID), digest);
+  }
+  return digestLen;
+}
+
+UInt compChecksum(Int bitdepth, const Pel* plane, UInt width, UInt height, UInt stride, TComPictureHash &digest, const BitDepths &/*bitDepths*/)
 {
   UInt checksum = 0;
@@ -158,24 +158,21 @@
   }
 
-  digest[0] = (checksum>>24) & 0xff;
-  digest[1] = (checksum>>16) & 0xff;
-  digest[2] = (checksum>>8)  & 0xff;
-  digest[3] =  checksum      & 0xff;
-}
-
-void calcChecksum(TComPicYuv& pic, UChar digest[3][16])
-{
-  UInt width = pic.getWidth();
-  UInt height = pic.getHeight();
-  UInt stride = pic.getStride();
-
-  compChecksum(g_bitDepthY, pic.getLumaAddr(), width, height, stride, digest[0]);
-
-  width >>= 1;
-  height >>= 1;
-  stride >>= 1;
-
-  compChecksum(g_bitDepthC, pic.getCbAddr(), width, height, stride, digest[1]);
-  compChecksum(g_bitDepthC, pic.getCrAddr(), width, height, stride, digest[2]);
+  digest.hash.push_back((checksum>>24) & 0xff);
+  digest.hash.push_back((checksum>>16) & 0xff);
+  digest.hash.push_back((checksum>>8)  & 0xff);
+  digest.hash.push_back( checksum      & 0xff);
+  return 4;
+}
+
+UInt calcChecksum(const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths)
+{
+  UInt digestLen=0;
+  digest.hash.clear();
+  for(Int chan=0; chan<pic.getNumberValidComponents(); chan++)
+  {
+    const ComponentID compID=ComponentID(chan);
+    digestLen=compChecksum(bitDepths.recon[toChannelType(compID)], pic.getAddr(compID), pic.getWidth(compID), pic.getHeight(compID), pic.getStride(compID), digest, bitDepths);
+  }
+  return digestLen;
 }
 /**
@@ -186,29 +183,45 @@
  * uses little-endian two byte words; 8bit data uses single byte words.
  */
-void calcMD5(TComPicYuv& pic, UChar digest[3][16])
+UInt calcMD5(const TComPicYuv& pic, TComPictureHash &digest, const BitDepths &bitDepths)
 {
   /* choose an md5_plane packing function based on the system bitdepth */
-  typedef void (*MD5PlaneFunc)(MD5&, const Pel*, UInt, UInt, UInt);
+  typedef Void (*MD5PlaneFunc)(MD5&, const Pel*, UInt, UInt, UInt);
   MD5PlaneFunc md5_plane_func;
-  md5_plane_func = g_bitDepthY <= 8 ? (MD5PlaneFunc)md5_plane<1> : (MD5PlaneFunc)md5_plane<2>;
-
-  MD5 md5Y, md5U, md5V;
-  UInt width = pic.getWidth();
-  UInt height = pic.getHeight();
-  UInt stride = pic.getStride();
-
-  md5_plane_func(md5Y, pic.getLumaAddr(), width, height, stride);
-  md5Y.finalize(digest[0]);
-
-  md5_plane_func = g_bitDepthC <= 8 ? (MD5PlaneFunc)md5_plane<1> : (MD5PlaneFunc)md5_plane<2>;
-  width >>= 1;
-  height >>= 1;
-  stride >>= 1;
-
-  md5_plane_func(md5U, pic.getCbAddr(), width, height, stride);
-  md5U.finalize(digest[1]);
-
-  md5_plane_func(md5V, pic.getCrAddr(), width, height, stride);
-  md5V.finalize(digest[2]);
-}
+
+  MD5 md5[MAX_NUM_COMPONENT];
+
+  digest.hash.clear();
+  for(Int chan=0; chan<pic.getNumberValidComponents(); chan++)
+  {
+    const ComponentID compID=ComponentID(chan);
+    md5_plane_func = bitDepths.recon[toChannelType(compID)] <= 8 ? (MD5PlaneFunc)md5_plane<1> : (MD5PlaneFunc)md5_plane<2>;
+    UChar tmp_digest[MD5_DIGEST_STRING_LENGTH];
+    md5_plane_func(md5[compID], pic.getAddr(compID), pic.getWidth(compID), pic.getHeight(compID), pic.getStride(compID));
+    md5[compID].finalize(tmp_digest);
+    for(UInt i=0; i<MD5_DIGEST_STRING_LENGTH; i++)
+    {
+      digest.hash.push_back(tmp_digest[i]);
+    }
+  }
+  return 16;
+}
+
+std::string hashToString(const TComPictureHash &digest, Int numChar)
+{
+  static const Char* hex = "0123456789abcdef";
+  std::string result;
+
+  for(Int pos=0; pos<Int(digest.hash.size()); pos++)
+  {
+    if ((pos % numChar) == 0 && pos!=0 )
+    {
+      result += ',';
+    }
+    result += hex[digest.hash[pos] >> 4];
+    result += hex[digest.hash[pos] & 0xf];
+  }
+
+  return result;
+}
+
 //! \}
